services:
  redis:
    image: redis:7.0-alpine
    restart: unless-stopped
    volumes:
      - {{ PROJECT_ROOT}}/{{ CI_ENVIRONMENT_NAME }}/redis/data:/data
    networks:
      - iber

  {{ SERVICE_NAME }}_app:
    image: {{ CI_REGISTRY_IMAGE }}:{{ CI_COMMIT_REF_SLUG }}
    build: .
    restart: unless-stopped
    environment: &app_envs
      DJANGO_SECRET_KEY: {{ DJANGO_SECRET_KEY }}
      DJANGO_ENV: {{ CI_ENVIRONMENT_NAME }}
      
      DATABASE_HOST: {{ DATABASE_HOST }}
      DATABASE_PORT: {{ DATABASE_PORT }}
      POSTGRES_USER: {{ POSTGRES_USER }}
      POSTGRES_PASSWORD: {{ POSTGRES_PASSWORD }}
      POSTGRES_DB: {{ POSTGRES_DB }}
      
      MAILGUN_API_KEY: {{ MAILGUN_API_KEY }}

      DOMAIN_NAME: {{ DOMAIN_NAME }}
      PROJECT_URI: {{ PROJECT_URI }}
    volumes: &app_vols
      - {{ PROJECT_ROOT}}/{{ CI_ENVIRONMENT_NAME }}/static/:/srv/static
      - {{ PROJECT_ROOT}}/{{ CI_ENVIRONMENT_NAME }}/media/:/srv/media
    networks:
      - iber
    links:
      - redis
    depends_on:
      - redis
    command: [ 'make', 'gunicorn' ]
    expose:
      - 8000
    labels:
      traefik.enable: "true"
      traefik.http.routers.{{ CI_ENVIRONMENT_NAME }}_{{ SERVICE_NAME }}.rule: Host(`{{ DOMAIN_NAME }}`) && PathPrefix(`{{ PROJECT_URI }}`)
      traefik.http.services.{{ CI_ENVIRONMENT_NAME }}_{{ SERVICE_NAME }}.loadbalancer.server.port: 8000

  {{ SERVICE_NAME }}_celery:
    image: {{ CI_REGISTRY_IMAGE }}:{{ CI_COMMIT_REF_SLUG }}
    restart: unless-stopped
    environment: *app_envs
    networks:
      - iber
    volumes: *app_vols
    links:
      - redis
    depends_on:
      - redis
    command: [ 'make', 'celery' ]
